require "./lib/pract/sort.rb"

  class Alimento
  include Comparable
  attr_accessor :name, :protein, :glucid, :lipid, :glucose

  #Constructor
  #@ param name  of food [String] and the attributes: protein, glucid, lipid
  	def initialize (name, protein, glucid, lipid, glucose)
 		@name = name
 		@protein = protein
 		@glucid = glucid
		@lipid = lipid
      @glucose = glucose
  	end
  #@return the energy provided by proteins
  	def protein_energy
  		return @protein * 4
  	end
  #@return the energy provided by glucids
  	def glucid_energy
  		return @glucid * 4
  	end
  #@return the energy provided by lipids
  	def lipid_energy
  		return @lipid * 9
  	end
  #@return the total energy of food
  	def energy
  		return glucid_energy + protein_energy + lipid_energy
  	end
  #@return the format showed by puts
  	def to_s
  		return "#{@name}: #{@protein}g proteinas, #{@glucid}g glucidos, #{@lipid}g grasas"
  	end
  #@return only name and total energy
  	def show_energy
  		return "#{@name}: #{self.energy.round(2)} Kcal."
  	end
  #Make it comparable
    def <=> (other)
      return self.energy <=> other.energy
    end
  #Define also the function == in comparable
    def == (other)
      return self.energy == other.energy
    end

    def aibc
       aux = @glucose.each_with_index.map do # i es el value , m es el indice
          |i, m| @glucose[m].each_with_index.map do
             |i, n|
               if(n>0)
                 i-@glucose[m][0] + (@glucose[m][n-1]-@glucose[m][0])
               else
                 0
               end
            end.each.collect{|i| i.round(2)/2*5}.reduce('+')
         end
       return aux
    end
  end
