require "./lib/pract.rb"
require "./lib/pract/list.rb"

class Grupo < Alimento
	#Constructor
	#@param group_name as the name of the list
	#@val as the first element of the list
	def initialize (group_name)
		super(group_name, 0, 0, 0, [])
 		@lista = Lista.new
	end
	#String format
	def to_s
		elements = @name + ":"
		elements << @lista.to_s
		#point = @lista.head
		#while(@lista.tail != point)
		#	elements = elements + point.val.name + ", "
		#	point = point.next
		#end
		#elements = elements + @lista.tail.val.name + " ]"
	end
	#Insert val to the last
	def insert (val)
		@lista.add_last(val)
	end
	#Remove an element called val
	def delete (val)
		@lista.remove(val)
	end
	#@return whether val is in the list or not
	def has_a(val)
		if(@lista.search(val) != 0)
			return true
		else
			return false
		end
	end
	#@return the energy provided by proteins of all foods in the list
	def protein_energy
  		@protein = 0
  		point = @lista.head
  		while(@lista.tail != point)
			@protein = @protein + point.val.protein_energy
			point = point.next
		end
		@protein = @protein + @lista.tail.val.protein_energy
  		return @protein
  	end
  	#@return the energy provided by glucids of all foods in the list
  	def glucid_energy
  		@glucid = 0
  		point = @lista.head
  		while(@lista.tail != point)
			@glucid = @glucid + point.val.glucid_energy
			point = point.next
		end
		@glucid = @glucid + @lista.tail.val.glucid_energy
  		return @glucid
  	end
  	#@return the energy provided by lipids of all foods in the list
  	def lipid_energy
  		@lipid = 0
  		point = @lista.head
  		while(@lista.tail != point)
			@lipid = @lipid + point.val.lipid_energy
			point = point.next
		end
		@lipid = @lipid + @lista.tail.val.lipid_energy
  		return @lipid
  	end
end
