require "./lib/pract/nodo.rb"

class Lista
	include Enumerable
	attr_accessor :head, :tail

	#Constructor
	#@param val as first element
	def initialize
		@head = @tail = nil
	end
	#@param point as auxiliar pointer
	#@param elements as showing variable
	#@return string format
	def to_s
		elements = "["
		point = @head
			while point != @tail
				elements = elements + point.val.to_s
 				elements = elements + "], ["
				point = point.next
			end
		if (@head != nil)
			elements = elements + point.val.to_s
		end
		elements = elements + "]"
	end
	#Add val as last element
	def add_last (val)
	   if (@head!= nil)
			point = @tail
			point.next = Nodo.new(point, val, nil)
			@tail = point.next
		else
			@head = @tail = Nodo.new(nil, val, nil)
		end
	end
	#Add val as first element
	def add_first (val)
		if (@head!= nil)
			point = @head
			point.prev = Nodo.new(nil, val, point)
			@head = point.prev
		else
			@head = @tail = Nodo.new(nil, val, nil)
		end
	end
	#Remove the first element
	def remove_first
		point = @head
		@head = point.next
	end
	#Remove the last element
	def remove_last
		point = @tail
		@tail = point.prev
	end
	#Remove an element
	#@param val [value] as the value we want to remove
	def remove (val)
	 	if (@head != nil)
	  		if(@head == @tail) && (@head.val == val)
				@head = nil
				@tail = nil
			elsif (@head.val == val)
				remove_first
			elsif (@tail.val == val)
				remove_last
			else
				point = @head
				while (point.next != nil) && (point.val != val)
					point = point.next
				end
				if point != @tail
					before = point.prev
					after = point.next
					before.next = after
					after.prev = before
					point.prev = nil
					point.next = nil
				end
			end
	 	end
	end
	#@return size of element
	def sz
		size_list = 0
		point = @head
		while(point != tail)
			size_list = size_list + 1
			point = point.next
		end
		size_list = size_list+1
		return size_list
	end
	#@return position of val[from 1] or nil is not found
	def search(val)
		num = 1
		point = @head
		while(point != @tail)
			if(point.val == val)
				return num
			else
				num = num+1
				point = point.next
			end
		end
		if @tail.val == val
			return num
		else return 0
		end
	end
	#Make list enumerable
	def each
		point = @head
		while(point != @tail) do
			yield point.val
			point = point.next
		end
		yield(point.val)
	end
end
